diff --git a/ldap/servers/plugins/replication/urp.c b/ldap/servers/plugins/replication/urp.c
index 0e76699..3d63c64 100644
--- a/ldap/servers/plugins/replication/urp.c
+++ b/ldap/servers/plugins/replication/urp.c
@@ -1135,25 +1977,15 @@ urp_naming_conflict_removal(Slapi_PBlock *pb, char *sessionid, CSN *opcsn, const
      * will acquire the DB lock if it sees this flag.
      */
     op_result = urp_fixup_rename_entry((const Slapi_Entry *)min_naming_conflict_entry, newrdnstr, NULL, OP_FLAG_ACTION_INVOKE_FOR_REPLOP);
-    if (op_result != LDAP_SUCCESS) {
+    if ( op_result != LDAP_SUCCESS ) {
         slapi_log_err(slapi_log_urp, sessionid,
-                      "urp_naming_conflict_removal - Failed to restore RDN of %s, err=%d\n", oldrdnstr, op_result);
+            "urp_naming_conflict_removal - Failed to restore RDN of %s, err=%d\n", oldrdnstr, op_result);
         goto bailout;
     }
     slapi_log_err(slapi_log_urp, sessionid,
                   "urp_naming_conflict_removal - Naming conflict removed by %s. RDN of %s was restored\n", optype, oldrdnstr);
-
-    /* Step2: Remove ATTR_NSDS5_REPLCONFLICT from the winning entry */
-    /*
-     * A fixup op will not invoke urp_modrdn_operation(). Even it does,
-     * urp_modrdn_operation() will do nothing because of the same CSN.
-     */
-    op_result = del_replconflict_attr(min_naming_conflict_entry, opcsn, OP_FLAG_ACTION_INVOKE_FOR_REPLOP);
-    if (op_result != LDAP_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_REPL, sessionid,
-                      "urp_naming_conflict_removal - Failed to remove nsds5ReplConflict for %s, err=%d\n",
-                      newrdnstr, op_result);
-    }
+            
+    /* end Step 1 */
 
 bailout:
     slapi_entry_free(min_naming_conflict_entry);
@@ -1207,17 +2039,16 @@ char *
 get_rdn_plus_uniqueid(char *sessionid, const char *olddn, const char *uniqueid)
 {
     char *newrdn = NULL;
+    Slapi_RDN *rdn = NULL;
     /* Check if the RDN already contains the Unique ID */
-    Slapi_DN *sdn = slapi_sdn_new_dn_byval(olddn);
-    Slapi_RDN *rdn = slapi_rdn_new();
-    int rc = slapi_rdn_init_all_sdn_ext(rdn, sdn, 1);
-    if (rc) {
+    rdn = slapi_rdn_new_dn(olddn);
+    if (rdn == NULL) {
         slapi_log_err(SLAPI_LOG_ERR, sessionid,
                       "Failed to convert %s to RDN\n", olddn);
         goto bail;
     }
 
-    PR_ASSERT(uniqueid != NULL);
+    PR_ASSERT(uniqueid!=NULL);
     if (slapi_rdn_is_conflict(rdn)) {
         /* The Unique ID is already in the RDN.
          * This is a highly improbable collision.
@@ -1228,16 +2059,55 @@ get_rdn_plus_uniqueid(char *sessionid, const char *olddn, const char *uniqueid)
         slapi_log_err(SLAPI_LOG_WARNING, sessionid,
                       "get_rdn_plus_uniqueid - Annotated RDN %s has naming conflict\n", olddn);
     } else {
-        slapi_rdn_add(rdn, SLAPI_ATTR_UNIQUEID, uniqueid);
+        slapi_rdn_add(rdn,SLAPI_ATTR_UNIQUEID,uniqueid);
         newrdn = slapi_ch_strdup(slapi_rdn_get_rdn(rdn));
     }
 bail:
-    slapi_sdn_free(&sdn);
     slapi_rdn_free(&rdn);
     return newrdn;
 }
 
 static int
+is_deleted_at_csn(const Slapi_Entry *entry, CSN *opcsn)
+{
+    int rc = 0;
+    char *tombstone_csnstr = slapi_entry_attr_get_charptr(entry, "nstombstonecsn" );
+    CSN *tombstone_csn = csn_new_by_string(tombstone_csnstr);
+
+    if (csn_compare (tombstone_csn, opcsn) == 0) rc = 1;
+
+    slapi_ch_free_string(&tombstone_csnstr);
+    csn_free(&tombstone_csn);
+
+    return rc;
+}
+int
+is_conflict_entry(const Slapi_Entry *entry)
+{
+    int is_conflict = 0;
+    char *replconflict = slapi_entry_attr_get_charptr(entry,ATTR_NSDS5_REPLCONFLICT );
+    if (replconflict) {
+        is_conflict = 1;
+        slapi_ch_free_string(&replconflict);
+    }
+
+    return is_conflict;
+}
+static int
+is_renamed_entry(Slapi_PBlock *pb, Slapi_Entry *entry, CSN *opcsn)
+{
+    int rc = 0;
+    Slapi_DN *del_dn = NULL;
+    slapi_pblock_get(pb, SLAPI_DELETE_TARGET_SDN, &del_dn);
+    if (slapi_sdn_compare(del_dn, slapi_entry_get_sdn(entry))) {
+        /* the existing entry was renamed, check if it was before the delete */
+        if (csn_compare (entry_get_dncsn(entry), opcsn) < 0) rc = 1;
+    }
+
+    return rc;
+}
+
+static int
 is_suffix_entry(Slapi_PBlock *pb, Slapi_Entry *entry, Slapi_DN **parentdn)
 {
     return is_suffix_dn(pb, slapi_entry_get_sdn(entry), parentdn);
@@ -1272,16 +2142,11 @@ mod_namingconflict_attr(const char *uniqueid, const Slapi_DN *entrysdn, const Sl
     char buf[BUFSIZ];
     int op_result;
 
-#ifdef DEBUG
     PR_snprintf(buf, sizeof(buf), "%s (%s) %s",
-                REASON_ANNOTATE_DN, optype, slapi_sdn_get_dn(conflictsdn));
-#else
-    PR_snprintf(buf, sizeof(buf), "%s %s",
-                REASON_ANNOTATE_DN, slapi_sdn_get_dn(conflictsdn));
-#endif
+                 REASON_ANNOTATE_DN, optype, slapi_sdn_get_dn(conflictsdn));
     slapi_mods_init(&smods, 2);
-    if (strncmp(slapi_sdn_get_dn(entrysdn), SLAPI_ATTR_UNIQUEID,
-                strlen(SLAPI_ATTR_UNIQUEID)) != 0) {
+    if ( strncmp(slapi_sdn_get_dn(entrysdn), SLAPI_ATTR_UNIQUEID,
+         strlen(SLAPI_ATTR_UNIQUEID)) != 0 ) {
         slapi_mods_add(&smods, LDAP_MOD_ADD, ATTR_NSDS5_REPLCONFLICT, strlen(buf), buf);
     } else {
         /*
@@ -1297,6 +2162,25 @@ mod_namingconflict_attr(const char *uniqueid, const Slapi_DN *entrysdn, const Sl
 }
 
 static int
+mod_objectclass_attr(const char *uniqueid, const Slapi_DN *entrysdn, const Slapi_DN *conflictsdn, CSN *opcsn, const char *optype)
+{
+    Slapi_Mods smods;
+    int op_result;
+    char csnstr[CSN_STRSIZE+1];
+
+    slapi_mods_init(&smods, 3);
+    slapi_mods_add(&smods, LDAP_MOD_ADD, "objectclass", strlen("ldapsubentry"),"ldapsubentry");
+    slapi_mods_add(&smods, LDAP_MOD_REPLACE, "conflictcsn", strlen(csnstr),csn_as_string(opcsn, PR_FALSE, csnstr));
+    op_result = urp_fixup_modify_entry(uniqueid, entrysdn, opcsn, &smods, 0);
+    slapi_mods_done(&smods);
+    if (op_result == LDAP_TYPE_OR_VALUE_EXISTS) {
+        /* the objectclass was already present */
+        op_result = LDAP_SUCCESS;
+    }
+    return op_result;
+}
+
+static int
 del_replconflict_attr(const Slapi_Entry *entry, CSN *opcsn, int opflags)
 {
     Slapi_Attr *attr;
@@ -1309,8 +2193,9 @@ del_replconflict_attr(const Slapi_Entry *entry, CSN *opcsn, int opflags)
 
         uniqueid = slapi_entry_get_uniqueid(entry);
         entrysdn = slapi_entry_get_sdn_const(entry);
-        slapi_mods_init(&smods, 2);
+        slapi_mods_init(&smods, 3);
         slapi_mods_add(&smods, LDAP_MOD_DELETE, ATTR_NSDS5_REPLCONFLICT, 0, NULL);
+        slapi_mods_add(&smods, LDAP_MOD_DELETE, "objectclass", strlen("ldapsubentry"),"ldapsubentry");
         op_result = urp_fixup_modify_entry(uniqueid, entrysdn, opcsn, &smods, opflags);
         slapi_mods_done(&smods);
     }
diff --git a/ldap/servers/plugins/replication/urp.h b/ldap/servers/plugins/replication/urp.h
index c641ab9..d88dfbc 100644
--- a/ldap/servers/plugins/replication/urp.h
+++ b/ldap/servers/plugins/replication/urp.h
@@ -23,6 +23,7 @@
 int urp_modify_operation(Slapi_PBlock *pb);
 int urp_add_operation(Slapi_PBlock *pb);
 int urp_delete_operation(Slapi_PBlock *pb);
+int urp_post_add_operation(Slapi_PBlock *pb);
 int urp_post_delete_operation(Slapi_PBlock *pb);
 int urp_modrdn_operation(Slapi_PBlock *pb);
 int urp_post_modrdn_operation(Slapi_PBlock *pb);
@@ -33,6 +34,7 @@ int urp_fixup_add_entry(Slapi_Entry *e, const char *target_uniqueid, const char
 int urp_fixup_delete_entry(const char *uniqueid, const char *dn, CSN *opcsn, int opflags);
 int urp_fixup_rename_entry(const Slapi_Entry *entry, const char *newrdn, const char *parentuniqueid, int opflags);
 int urp_fixup_modify_entry(const char *uniqueid, const Slapi_DN *sdn, CSN *opcsn, Slapi_Mods *smods, int opflags);
+int urp_fixup_modrdn_entry(const Slapi_DN *entrydn, const char *newrdn, const Slapi_DN *newsuperior, const char *entryuniqueid, const char *parentuniqueid, CSN *opcsn, int opflags);
 
 int is_suffix_dn(Slapi_PBlock *pb, const Slapi_DN *dn, Slapi_DN **parenddn);
 int is_suffix_dn_ext(Slapi_PBlock *pb, const Slapi_DN *dn, Slapi_DN **parenddn, int is_tombstone);
@@ -41,6 +43,7 @@ int is_suffix_dn_ext(Slapi_PBlock *pb, const Slapi_DN *dn, Slapi_DN **parenddn,
  * urp_glue.c
  */
 int is_glue_entry(const Slapi_Entry *entry);
+int is_conflict_entry(const Slapi_Entry *entry);
 int create_glue_entry(Slapi_PBlock *pb, char *sessionid, Slapi_DN *dn, const char *uniqueid, CSN *opcsn);
 int entry_to_glue(char *sessionid, const Slapi_Entry *entry, const char *reason, CSN *opcsn);
 int glue_to_entry(Slapi_PBlock *pb, Slapi_Entry *entry);
@@ -51,5 +54,8 @@ PRBool get_glue_csn(const Slapi_Entry *entry, const CSN **gluecsn);
  */
 int is_tombstone_entry(const Slapi_Entry *entry);
 int tombstone_to_glue(Slapi_PBlock *pb, char *sessionid, Slapi_Entry *entry, const Slapi_DN *parentdn, const char *reason, CSN *opcsn, Slapi_DN **newparentdn);
+int tombstone_to_conflict(char *sessionid, Slapi_Entry *entry, const Slapi_DN *conflictdn, const char *reason, CSN *opcsn,     Slapi_DN **newparentdn);
+int conflict_to_tombstone(char *sessionid, Slapi_Entry *entry, CSN *opcsn);
+int tombstone_to_conflict_check_parent( char *sessionid, char *parentdn, const char *uniqueid, const char *parentuniqueid, CSN *opcsn, Slapi_DN *conflictdn);
 int entry_to_tombstone(Slapi_PBlock *pb, Slapi_Entry *entry);
 PRBool get_tombstone_csn(const Slapi_Entry *entry, const CSN **delcsn);
diff --git a/ldap/servers/plugins/replication/urp_glue.c b/ldap/servers/plugins/replication/urp_glue.c
index 80ece48..262a93f 100644
--- a/ldap/servers/plugins/replication/urp_glue.c
+++ b/ldap/servers/plugins/replication/urp_glue.c
@@ -63,7 +63,7 @@ get_glue_csn(const Slapi_Entry *entry, const CSN **gluecsn)
 int
 entry_to_glue(char *sessionid, const Slapi_Entry *entry, const char *reason, CSN *opcsn)
 {
-    int op_result = 0;
+    int op_result = -1;
     const char *dn;
     const Slapi_DN *sdn;
     slapi_mods smods;
diff --git a/ldap/servers/plugins/replication/urp_tombstone.c b/ldap/servers/plugins/replication/urp_tombstone.c
index 67bfefc..9f1f060 100644
--- a/ldap/servers/plugins/replication/urp_tombstone.c
+++ b/ldap/servers/plugins/replication/urp_tombstone.c
@@ -51,6 +51,99 @@ get_tombstone_csn(const Slapi_Entry *entry, const CSN **delcsn)
     return ists;
 }
 
+static Slapi_DN*
+get_valid_parent_for_conflict(Slapi_Entry *entry)
+{
+	char *replconflict = slapi_entry_attr_get_charptr(entry,ATTR_NSDS5_REPLCONFLICT );
+	char *validdn = NULL;
+	Slapi_DN *valid_DN = NULL;
+
+	if (replconflict) {
+		validdn = strstr(replconflict, " (ADD) ");
+		if (validdn) {
+			validdn += 7;
+			valid_DN = slapi_sdn_new_dn_byval(validdn);
+			slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
+				"get_valid_parent_for_conflict - valid entry dn: %s\n",
+				validdn);
+		}
+		slapi_ch_free_string(&replconflict);
+	}
+	return valid_DN;
+}
+
+int
+tombstone_to_conflict_check_parent (
+	char *sessionid,
+	char *parentdn,
+	const char *uniqueid,
+	const char *parentuniqueid,
+	CSN *opcsn,
+	Slapi_DN *conflictdn)
+{
+	int rc = 0;
+	int op_result;
+	Slapi_PBlock *newpb;
+
+	if (parentdn == 0) {
+		slapi_log_err(SLAPI_LOG_REPL, sessionid,
+				"tombstone_to_conflict_check_parent - no parent entry for: %s\n",
+				slapi_sdn_get_ndn(conflictdn));
+		return rc;
+	} else {
+		slapi_log_err(SLAPI_LOG_REPL, sessionid,
+				"tombstone_to_conflict_check_parent - checking parent entry: %s\n",
+				parentdn);
+	}
+	newpb = slapi_pblock_new();
+	slapi_search_internal_set_pb(
+					newpb,
+					parentdn,
+					LDAP_SCOPE_BASE,
+					"objectclass=*",
+					NULL, /*attrs*/
+					0, /*attrsonly*/
+					NULL, /*Controls*/
+					parentuniqueid, /*uniqueid*/
+					repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION),
+					0);
+	slapi_search_internal_pb(newpb); 
+	slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_RESULT, &op_result);
+	switch(op_result)
+	{
+	case LDAP_SUCCESS:
+		{
+		Slapi_Entry **entries= NULL;
+		slapi_pblock_get(newpb, SLAPI_PLUGIN_INTOP_SEARCH_ENTRIES, &entries);
+		if(entries!=NULL && entries[0]!=NULL) {
+			if(is_conflict_entry(entries[0])) {
+				Slapi_DN *newsuperior = get_valid_parent_for_conflict(entries[0]);
+				Slapi_RDN *rdn = slapi_rdn_new();
+				slapi_sdn_get_rdn(conflictdn, rdn);
+				const char *newrdn = slapi_rdn_get_rdn(rdn);
+				op_result= urp_fixup_modrdn_entry(
+					conflictdn,
+					newrdn,
+					newsuperior,
+					uniqueid,
+					NULL,
+					NULL,
+					OP_FLAG_NOOP);
+				slapi_rdn_free(&rdn);
+				slapi_sdn_free(&newsuperior);
+			}
+		}
+		}
+		break;
+	default:
+		break;
+	}
+
+	slapi_free_search_results_internal (newpb);
+	slapi_pblock_destroy(newpb);
+	return rc;
+}
+
 static int
 tombstone_to_glue_resolve_parent(
     Slapi_PBlock *pb,
@@ -103,6 +196,118 @@ tombstone_to_glue_resolve_parent(
 }
 
 /*
+ * transform a conflict entry to a tombstone of the original entry
+ * 1. rename the conflict to the original entry
+ * 2. remove conflict attrs
+ * 3. delete it
+ */
+
+int
+conflict_to_tombstone(char *sessionid, Slapi_Entry *entry, CSN *opcsn)
+{
+	int op_result = 0;
+	Slapi_RDN *srdn = slapi_rdn_new();
+	const char *uniqueid = slapi_entry_get_uniqueid ( entry );
+	const char *newrdn = NULL;
+	char *conflictdn = NULL;
+	char *replconflict = slapi_entry_attr_get_charptr(entry,ATTR_NSDS5_REPLCONFLICT );
+
+	if (replconflict) {
+		conflictdn = strstr(replconflict, " (ADD) ");
+		if (conflictdn == NULL) {
+			/* error, wrong type of conflict */
+			op_result = 1;
+		} else {
+			conflictdn += 7;
+			slapi_rdn_init_all_dn(srdn, conflictdn);
+			newrdn = slapi_rdn_get_nrdn(srdn);
+			slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
+				"conflict_to_tombstone - %s - valid entry dn: %s newrdn: %s\n",
+				sessionid, conflictdn, newrdn);
+		}
+	}
+
+	if (op_result) goto done;
+
+	slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
+			"conflict_to_tombstone - %s - Renaming entry %s to %s\n",
+			sessionid, slapi_entry_get_dn_const (entry), newrdn);
+	op_result = urp_fixup_rename_entry(entry, newrdn, NULL, OP_FLAG_NOOP);
+	if (op_result) goto done;
+
+	op_result = urp_fixup_delete_entry (uniqueid, slapi_entry_get_dn_const (entry), opcsn, 0);
+
+done: 
+	slapi_ch_free_string(&replconflict);
+	slapi_rdn_free(&srdn);
+	return op_result;
+}
+
+/*
+ * Convert a tombstone into a conflict entry.
+ */
+int
+tombstone_to_conflict (
+	char *sessionid,
+	Slapi_Entry *tombstoneentry,
+	const Slapi_DN *conflictdn,
+	const char *reason,
+	CSN *opcsn,
+	Slapi_DN **newparentdn)
+{
+	int op_result = 0;
+	Slapi_Mods smods;
+	char csnstr[CSN_STRSIZE+1];
+	char buf[BUFSIZ];
+	char *uniqueid = slapi_entry_attr_get_charptr(tombstoneentry, "nsuiqueid");
+	char *entrydn = slapi_entry_attr_get_charptr(tombstoneentry, "nscpentrydn");
+	char *parentuniqueid = slapi_entry_attr_get_charptr (tombstoneentry, SLAPI_ATTR_VALUE_PARENT_UNIQUEID); /* Allocated */
+	char *parentdn = slapi_dn_parent(slapi_sdn_get_ndn(conflictdn));
+	const CSN *dncsn = entry_get_dncsn(tombstoneentry);
+	csn_as_string(dncsn, PR_FALSE, csnstr);
+
+	slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
+			                 "tombstone_to_conflict - %s - trying to resurrect tombstone as '%s'.\n",
+			                 sessionid, slapi_sdn_get_ndn(conflictdn));
+	slapi_sdn_set_normdn_byval(slapi_entry_get_sdn(tombstoneentry), slapi_sdn_get_ndn(conflictdn));
+	/* not just e_sdn, e_rsdn needs to be updated. */
+	slapi_rdn_set_all_dn(slapi_entry_get_srdn(tombstoneentry), slapi_sdn_get_ndn(conflictdn));
+	op_result = urp_fixup_add_entry (tombstoneentry, NULL, NULL, opcsn, OP_FLAG_RESURECT_ENTRY|OP_FLAG_NOOP);
+
+	if (op_result) {
+		slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name,
+			"tombstone_to_conflict - %s - Can't resurrect tombstone, error=%d\n",
+			sessionid, op_result);
+		goto done;
+	}
+
+	slapi_mods_init (&smods, 5);
+	slapi_mods_add (&smods, LDAP_MOD_ADD, "objectclass", strlen("ldapsubentry"),"ldapsubentry");
+	slapi_mods_add (&smods, LDAP_MOD_DELETE, "objectclass", strlen("glue"),"glue");
+	slapi_mods_add (&smods, LDAP_MOD_REPLACE, "conflictcsn", strlen(csnstr), csnstr);
+	PR_snprintf (buf, sizeof(buf), "%s (%s) %s",
+	             REASON_ANNOTATE_DN, "ADD", entrydn);
+	slapi_mods_add (&smods, LDAP_MOD_ADD, ATTR_NSDS5_REPLCONFLICT, strlen(buf), buf);
+	op_result = urp_fixup_modify_entry (uniqueid, conflictdn, opcsn, &smods, 0);
+	slapi_mods_done (&smods);
+	if (op_result == LDAP_TYPE_OR_VALUE_EXISTS) {
+		/* the objectclass was already present */
+		op_result = LDAP_SUCCESS;
+	}
+	/* this will go to postop 
+	if (op_result == LDAP_SUCCESS) {
+		op_result = tombstone_to_conflict_check_parent(sessionid, parentdn, uniqueid, parentuniqueid, opcsn, conflictdn);
+	}
+	*/
+done:
+	slapi_ch_free_string(&uniqueid);
+	slapi_ch_free_string(&parentuniqueid);
+	slapi_ch_free_string(&parentdn);
+	slapi_ch_free_string(&entrydn);
+	return op_result;
+}
+
+/*
  * Convert a tombstone into a glue entry.
  */
 int
diff --git a/ldap/servers/plugins/retrocl/retrocl_po.c b/ldap/servers/plugins/retrocl/retrocl_po.c
index eb46b95..d2af79b 100644
--- a/ldap/servers/plugins/retrocl/retrocl_po.c
+++ b/ldap/servers/plugins/retrocl/retrocl_po.c
@@ -638,7 +638,8 @@ retrocl_postob(Slapi_PBlock *pb, int optype)
         return SLAPI_PLUGIN_SUCCESS;
     }
 
-    if (operation_is_flag_set(op, OP_FLAG_TOMBSTONE_ENTRY)) {
+    if (operation_is_flag_set(op, OP_FLAG_TOMBSTONE_ENTRY) ||
+        operation_is_flag_set(op, OP_FLAG_NOOP)) {
         slapi_log_err(SLAPI_LOG_TRACE, RETROCL_PLUGIN_NAME, "retrocl_postob - Not applying change for nsTombstone entries\n");
         return SLAPI_PLUGIN_SUCCESS;
     }
